
package org.apache.beehive.controls.system.ejb;

import java.beans.*;

import java.lang.reflect.Method;
import java.lang.reflect.UndeclaredThrowableException;
import java.util.HashMap;
import java.util.Map;

import org.apache.beehive.controls.api.bean.*;
import org.apache.beehive.controls.api.context.ControlBeanContext;
import org.apache.beehive.controls.api.properties.PropertyKey;
import org.apache.beehive.controls.api.properties.PropertyMap;
import org.apache.beehive.controls.api.versioning.*;

@SuppressWarnings("all")
public class EJBControlBean
extends org.apache.beehive.controls.runtime.bean.ControlBean
implements org.apache.beehive.controls.system.ejb.EJBControl
{
    static final Method _getEJBBeanInstanceMethod;
    static final Method _getEJBHomeInstanceMethod;
    static final Method _getEJBExceptionMethod;
    static final Method _hasEJBBeanInstanceMethod;
    
    //
    // This HashMap will map from a Method to the array of names for parameters of the
    // method.  This is necessary because parameter name data isn't carried along in the
    // class file, but if available can enable ease of use by referencing parameters by
    // the declared name (vs. by index).
    //
    // This map should be read-only after its initialization in the static block, hence
    // using a plain HashMap is thread-safe.
    //
    static HashMap<Method, String []> _methodParamMap = new HashMap<Method, String []>();
    
    static
    {
        
        
        try
        {
            _getEJBBeanInstanceMethod = org.apache.beehive.controls.system.ejb.EJBControl.class.getMethod("getEJBBeanInstance", new Class [] {});
            _methodParamMap.put(_getEJBBeanInstanceMethod, new String [] {  });
            _getEJBHomeInstanceMethod = org.apache.beehive.controls.system.ejb.EJBControl.class.getMethod("getEJBHomeInstance", new Class [] {});
            _methodParamMap.put(_getEJBHomeInstanceMethod, new String [] {  });
            _getEJBExceptionMethod = org.apache.beehive.controls.system.ejb.EJBControl.class.getMethod("getEJBException", new Class [] {});
            _methodParamMap.put(_getEJBExceptionMethod, new String [] {  });
            _hasEJBBeanInstanceMethod = org.apache.beehive.controls.system.ejb.EJBControl.class.getMethod("hasEJBBeanInstance", new Class [] {});
            _methodParamMap.put(_hasEJBBeanInstanceMethod, new String [] {  });
        }
        catch (NoSuchMethodException __bc_nsme)
        {
            throw new ExceptionInInitializerError(__bc_nsme);
        }
    }
    
    
    
    static
    {
        
    }
    
    
    
    /**
    * This is the public constructor for the class.  A client-defined control ID may
    * be provided.  This ID must be unique within the nesting ControlBeanContext.
    * @param context The containing ControlBeanContext
    * @param id The control identifier (or null to autogenerate a unique value)
    * @param props The initialization Properties for the new instance (or null for defaults)
    */
    public EJBControlBean(ControlBeanContext context, String id, PropertyMap props)
    {
        this(context, id, props, org.apache.beehive.controls.system.ejb.EJBControl.class);
    }
    
    /**
    * This is the public null-arg constructor for this ControlBean.  If a control id
    * is not provided, a unique value will be auto-generated.
    */
    public EJBControlBean()
    {
        this(null, null, null);
    }
    
    /**
    * This is the protected version that is used by any ControlBean subclass
    */
    protected EJBControlBean(ControlBeanContext context, String id, PropertyMap props, Class controlClass)
    {
        super(context, id, props, controlClass);
        
    }
    
    
    /**
    * Returns an array of parameter names for the request method, or null if no parameter
    * data is available.
    */
    protected String [] getParameterNames(Method m)
    {
        // Check the local map for operations on this bean type
        if (_methodParamMap.containsKey(m))
        {
            return _methodParamMap.get(m);
        }
        
        // Delegate up if not found locally
        return super.getParameterNames(m);
    }
    
    /**
    * Implements org.apache.beehive.controls.system.ejb.EJBControl.getEJBBeanInstance
    */
    public  java.lang.Object getEJBBeanInstance() 
    {
        Object [] __bc_argArray = new Object[] {  };
        Throwable __bc_thrown = null;
        org.apache.beehive.controls.system.ejb.EJBControl __bc_target = (org.apache.beehive.controls.system.ejb.EJBControl)ensureControl();
        java.lang.Object __bc_retval = null;
        
        try
        {
            preInvoke(_getEJBBeanInstanceMethod, __bc_argArray);
            
            __bc_retval =
            __bc_target.getEJBBeanInstance()
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_getEJBBeanInstanceMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements org.apache.beehive.controls.system.ejb.EJBControl.getEJBHomeInstance
    */
    public  java.lang.Object getEJBHomeInstance() 
    {
        Object [] __bc_argArray = new Object[] {  };
        Throwable __bc_thrown = null;
        org.apache.beehive.controls.system.ejb.EJBControl __bc_target = (org.apache.beehive.controls.system.ejb.EJBControl)ensureControl();
        java.lang.Object __bc_retval = null;
        
        try
        {
            preInvoke(_getEJBHomeInstanceMethod, __bc_argArray);
            
            __bc_retval =
            __bc_target.getEJBHomeInstance()
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_getEJBHomeInstanceMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements org.apache.beehive.controls.system.ejb.EJBControl.getEJBException
    */
    public  java.lang.Throwable getEJBException() 
    {
        Object [] __bc_argArray = new Object[] {  };
        Throwable __bc_thrown = null;
        org.apache.beehive.controls.system.ejb.EJBControl __bc_target = (org.apache.beehive.controls.system.ejb.EJBControl)ensureControl();
        java.lang.Throwable __bc_retval = null;
        
        try
        {
            preInvoke(_getEJBExceptionMethod, __bc_argArray);
            
            __bc_retval =
            __bc_target.getEJBException()
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_getEJBExceptionMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements org.apache.beehive.controls.system.ejb.EJBControl.hasEJBBeanInstance
    */
    public  boolean hasEJBBeanInstance() 
    {
        Object [] __bc_argArray = new Object[] {  };
        Throwable __bc_thrown = null;
        org.apache.beehive.controls.system.ejb.EJBControl __bc_target = (org.apache.beehive.controls.system.ejb.EJBControl)ensureControl();
        boolean __bc_retval = false;
        
        try
        {
            preInvoke(_hasEJBBeanInstanceMethod, __bc_argArray);
            
            __bc_retval =
            __bc_target.hasEJBBeanInstance()
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_hasEJBBeanInstanceMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    
    /**
    * A PropertyKey that can be used to access the controlImplementation property of the
    * BaseProperties PropertySet
    */
    public static final PropertyKey ControlImplementationKey = new PropertyKey(org.apache.beehive.controls.api.properties.BaseProperties.class, "controlImplementation");
    
    public synchronized void setControlImplementation(java.lang.String value)
    {
        
        setControlProperty(ControlImplementationKey, value);
    }
    
    public java.lang.String getControlImplementation()
    {
        return (java.lang.String)getControlProperty(ControlImplementationKey);
    }
    
    /**
    * A PropertyKey that can be used to access the jndiName property of the
    * EJBHome PropertySet
    */
    public static final PropertyKey JndiNameKey = new PropertyKey(org.apache.beehive.controls.system.ejb.EJBControl.EJBHome.class, "jndiName");
    
    public synchronized void setJndiName(java.lang.String value)
    {
        
        setControlProperty(JndiNameKey, value);
    }
    
    public java.lang.String getJndiName()
    {
        return (java.lang.String)getControlProperty(JndiNameKey);
    }
    
    /**
    * A PropertyKey that can be used to access the ejbLink property of the
    * EJBHome PropertySet
    */
    public static final PropertyKey EjbLinkKey = new PropertyKey(org.apache.beehive.controls.system.ejb.EJBControl.EJBHome.class, "ejbLink");
    
    public synchronized void setEjbLink(java.lang.String value)
    {
        
        setControlProperty(EjbLinkKey, value);
    }
    
    public java.lang.String getEjbLink()
    {
        return (java.lang.String)getControlProperty(EjbLinkKey);
    }
    
    /**
    * A PropertyKey that can be used to access the contextFactory property of the
    * JNDIContextEnv PropertySet
    */
    public static final PropertyKey ContextFactoryKey = new PropertyKey(org.apache.beehive.controls.system.ejb.EJBControl.JNDIContextEnv.class, "contextFactory");
    
    public synchronized void setContextFactory(java.lang.String value)
    {
        
        setControlProperty(ContextFactoryKey, value);
    }
    
    public java.lang.String getContextFactory()
    {
        return (java.lang.String)getControlProperty(ContextFactoryKey);
    }
    
    /**
    * A PropertyKey that can be used to access the providerURL property of the
    * JNDIContextEnv PropertySet
    */
    public static final PropertyKey ProviderURLKey = new PropertyKey(org.apache.beehive.controls.system.ejb.EJBControl.JNDIContextEnv.class, "providerURL");
    
    public synchronized void setProviderURL(java.lang.String value)
    {
        
        setControlProperty(ProviderURLKey, value);
    }
    
    public java.lang.String getProviderURL()
    {
        return (java.lang.String)getControlProperty(ProviderURLKey);
    }
    
    /**
    * A PropertyKey that can be used to access the principal property of the
    * JNDIContextEnv PropertySet
    */
    public static final PropertyKey PrincipalKey = new PropertyKey(org.apache.beehive.controls.system.ejb.EJBControl.JNDIContextEnv.class, "principal");
    
    public synchronized void setPrincipal(java.lang.String value)
    {
        
        setControlProperty(PrincipalKey, value);
    }
    
    public java.lang.String getPrincipal()
    {
        return (java.lang.String)getControlProperty(PrincipalKey);
    }
    
    /**
    * A PropertyKey that can be used to access the credentials property of the
    * JNDIContextEnv PropertySet
    */
    public static final PropertyKey CredentialsKey = new PropertyKey(org.apache.beehive.controls.system.ejb.EJBControl.JNDIContextEnv.class, "credentials");
    
    public synchronized void setCredentials(java.lang.String value)
    {
        
        setControlProperty(CredentialsKey, value);
    }
    
    public java.lang.String getCredentials()
    {
        return (java.lang.String)getControlProperty(CredentialsKey);
    }
    
    
    
    
    
    /**
    * The _annotCache maintains a lookup cache from AnnotatedElements to an associated
    * PropertyMap.  This enables these maps to be shared across multiple beans.
    */
    static private HashMap __bc_annotCache = new HashMap();
    
    protected Map getPropertyMapCache() { return __bc_annotCache; }
    
    private static final long serialVersionUID = 1L;
}
